﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Telerik.WinControls.UI.Docking;
using System.Reflection;
using Telerik.WinControls;

namespace RadDockAutoHide
{

    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            this.Load += new EventHandler(Form1_Load);
        }

        void Form1_Load(object sender, EventArgs e)
        {
            this.radDock1.DockStateChanging += new DockStateChangingEventHandler(radDock1_DockStateChanging);
            this.radDock1.DockStateChanged += new DockWindowEventHandler(radDock1_DockStateChanged);

            radDock1.DockWindow(toolWindow1, DockPosition.Right);
            toolWindow1.AutoHide();
        }

        void radDock1_DockStateChanged(object sender, DockWindowEventArgs e)
        {
            if (e.DockWindow.DockState == DockState.AutoHide)
            {
                e.DockWindow.Tag = position;
            }
        }

        AutoHidePosition position;

        void radDock1_DockStateChanging(object sender, DockStateChangingEventArgs e)
        {
            if (e.DockWindow.DockState == DockState.Docked)
            {
                position = GetDockPostition(e.DockWindow);
            }
        }

        public AutoHidePosition GetDockPostition(DockWindow window)
        {
            Type type = typeof(RadDock);
            MethodInfo method = type.GetMethod("GetAutoHidePosition", BindingFlags.Instance | BindingFlags.NonPublic);
            object o = method.Invoke(this.radDock1, new object[] { (ToolTabStrip)this.radDock1[window.Name].TabStrip });
            AutoHidePosition aHPposition = (AutoHidePosition)o;
            return aHPposition;
        }

        public AutoHidePosition GetFinalPosition(DockWindow window)
        {
            if (window.DockState == DockState.Docked)
            {
                return GetDockPostition(window);
            }
            else if (window.DockState == DockState.AutoHide)
            {
                return (AutoHidePosition)window.Tag;
            }

            return AutoHidePosition.Auto;
        }

        private void radButton1_Click(object sender, EventArgs e)
        {
            RadMessageBox.Show(GetFinalPosition(this.toolWindow1).ToString(), "Current AutoHidePosition of toolWindow1", MessageBoxButtons.OK);
        }
    }
}

